<?php

/*!
 * authentication.php
 * Licensed under the GNU General Public License v3.0
 */

session_start();
require_once('connect.php');

$idnow = $_SESSION['user'];
$time = date('H:i:s');
$date = date('Y-m-d');

if(!isset($_COOKIE['usercookie']))
{
    if (!isset($_SESSION['usersession']) || !$_SESSION['usersession'])
    {
        echo '<script> alert("Zugriff verweigert! Bitte melden Sie sich zuerst an."); window.location.href="index.php";</script>';
    }
    else
    {
        $usercheck = 'SELECT username, groups FROM db_users WHERE id=\''.$idnow.'\';';
        $dbconnect->real_escape_string($usercheck);
        $query = mysqli_query($dbconnect, $usercheck);
        $fetch = mysqli_fetch_object($query);

        $username = $fetch->username;
        $group = $fetch->groups;
        $now = time();

        if ($now > $_SESSION['expire'])
        {
            session_unset();
            session_destroy();

            echo '<script> alert("Session abgelaufen! Bitte melden Sie sich erneut an."); window.location.href="index.php";</script>';
        }
        else
        {
            $_SESSION['group'] = $group;
            $_SESSION['start'] = time();
            $_SESSION['expire'] = $_SESSION['start'] + (30 * 60);
        }
    }
}
if(isset($_COOKIE['usercookie']))
{
$cookiedec = base64_decode($_COOKIE["usercookie"]);
$pieces = explode('-', $cookiedec);
$id = $pieces[0];
$group = $pieces[1];

$usercheck = 'SELECT username, password, groups FROM db_users WHERE id=\''.$id.'\';';
$dbconnect->real_escape_string($usercheck);
$query = mysqli_query($dbconnect, $usercheck);
$fetch = mysqli_fetch_object($query);

$cookietoken = sha1(''.$id.'-'.$group.'-'.substr($fetch->password, 7, 5).'-'.substr($fetch->username, 0, 5).'');
$username = $fetch->username;

    if(password_verify($cookietoken, $_COOKIE['usertoken']))
    {
        $_SESSION['usersession'] = true;
        $_SESSION['user'] = $id;
        $_SESSION['group'] = $group;
    }
    else
    {
        $_SESSION['usersession'] = false;
        setcookie('usercookie', '', time() - (63114 * 5000), "/");
        setcookie('usertoken', '', time() - (63114 * 5000), "/");
        session_unset();
        session_destroy();

        echo '<script> alert("Benutzerdaten geändert! Bitte melden Sie sich erneut an."); window.location.href="index.php";</script>';
    }
}
?>
